

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.List;
import java.util.Map.Entry;
import java.util.Set;

public class ConvertAnnotationFileFormat {

	public static void main(String[] args){
		try{
			BufferedReader in = new BufferedReader(new FileReader(new File("src/go/wikiBangladesh_annotations_Uniq.txt")));
			
			String s = in.readLine();
			
			Hashtable<String,List<String>> hash = new Hashtable<String, List<String>>();
			
			while(s!=null){
				String[] split = s.split(" ");
				String protein = split[0];
				for(int i = 1; i < split.length; i++){
					if(hash.containsKey(split[i])){
						List<String> proteins = hash.get(split[i]);
						proteins.add(protein);
						hash.remove(split[i]);
						hash.put(split[i],proteins);
						
					}
					else{
						List<String> proteins = new ArrayList<String>();
						proteins.add(protein);
						hash.put(split[i],proteins);
					}
				}
				
				s = in.readLine();
			}
			
			
			Set<Entry<String,List<String>>> entries = hash.entrySet();
			
			BufferedWriter out = new BufferedWriter(new FileWriter(new File("src/go/wikiBangladesh_Annotations_GoodFormat.txt")));
			for(Entry<String,List<String>> e: entries){
				out.write(e.getKey());
				for(String protein: e.getValue()){
					out.write("\t" + protein);
				}
				out.write("\n");
				out.flush();
			}
			out.close();
			
			for(Entry<String,List<String>> entry: entries){
				
			}
		}catch (Exception e) {
			e.printStackTrace();
		}
	}
}
